    Changelog

      Version 0.1

   07.04.2007
     * First release.

      Version 0.2

   09.04.2007
     * New features:
          + Added option to encrypt the stored form field rules - using
            Firefox nsISecretDecoderRing interface
          + Improved method to set the form field value for non-text form
            elements - loop until "Value" matches

      Version 0.3

   10.05.2007
     * New features:
          + Added profiles
          + Added profile switcher
          + Added shortcuts for profile switcher and settings page
          + Extended toolbar button to include menu items for profile
            switcher and settings page
          + Added 'Display Form Details' button on settings page to
            support creating form field rules
          + Added Rule Editor to help creating custom rules without
            regular expression knowledge
          + Improved settings page (using tabs, better structuring)
          + Extended help page

      Version 0.4

   16.05.2007
     * Bugfixes:
          + When moving rules up or down or adding new rules, the view
            scrolls now to ensure visibility
          + Added rules are inserted after the currently selected item
            instead of at the end of the list
     * New features:
          + If subsequent rules with the same fieldRule exist
            (Alternatives"), a prompt is displayed for selection
          + A new option defines if the selected alternatives index is to
            be used for subsequent selections
          + Extended help page to explain how the "Alternatives" work
     *

      Version 0.5

   16.05.2007
     * New features:
          + Added support for textareas
          + A new option defines a placeholder to create line breaks in
            textareas
          + Extended help page to explain how to use placeholders for line
            breaks

      Version 0.6

   19.05.2007
     * New features:
          + Added Import/Export feature for profiles

      Version 0.6.1

   06.06.2007
     * New features:
          + Improved default ruleset
          + Dialog windows independent from parent window
          + Highlight style using CSS declarations via about:config for
            matched and not matched form fields
          + Added support for password fields - for password management
            please rather use the Secure Login extension
          + Added french locale - Thanks to myahoo at babelzilla.org
          + Added dutch locale - Thanks to markh at babelzilla.org

      Version 0.6.1.1

   21.06.2007
     * New features:
          + Added czech locale - Thanks to PetrTwo at babelzilla.org

      Version 0.6.2

   05.07.2007
     * New features:
          + Added support for file upload fields

      Version 0.6.2.1

   18.07.2007
     * New features:
          + Added Chinese (Simplified) locale - Thanks to simophin at
            babelzilla.org

      Version 0.7

   31.07.2007
     * New features:
          + Added possibility to deselect checkboxes/radio buttons by
            deactivating the "Overwrite" setting
          + Added support for dynamic tags which can be used to insert
            dynamic data in form fields, e.g. the current date
          + Added possibility to fill out forms on all open tabs via
            about:config setting "fillAllTabs"
          + Added confirmation dialog before deleting a profile
          + Removed "Apply" button for field rules - field rules are now
            updated as soon as the textboxes lose focus
          + Updated documentation
          + Added Hungarian locale - Thanks to Mikes KaszmA!n IstvA!n
            (Cashman) at babelzilla.org
          + Added Italian locale - Thanks to Underpass, gonzalopirobutirro
            and Godai71 at babelzilla.org
          + Added Polish locale - Thanks to teo at babelzilla.org

      Version 0.7.0.1

   09.08.2007
     * User Interface improvements:
          + FieldRule list now takes up the free space when resizing the
            settings window
          + Rule editor list now takes up the free space when resizing the
            rule editor window
          + Rule editor textboxes now take up the free space when resizing
            the rule editor window
          + Tag editor list now takes up the free space when resizing the
            tag editor window
          + Tag editor tag code textboxes now take up the free space when
            resizing the tag editor window

      Version 0.7.0.2

   21.08.2007
     * Bugfixes:
          + If browser.preferences.animateFadeIn is set to true (which is
            the default on a Mac) the rule list had been hidden - fixed.

      Version 0.7.0.3

   11.09.2007
     * New features:
          + Added Chinese (Traditional) locale - Thanks to Lu Ming-Tse
            (aaaeae 3/4CUR).
          + Added Midbrowser (Firefox for Mobile Internet Devices) GUID to
            target applications (BETA) - see http://www.moblin.org.

      Version 0.8

   26.11.2007
     * New features:
          + Adding the possibility to define a Global Profile, which is
            applied on form fields that cannot be filled out using the
            current profile.
          + Applying the siteRule on the whole url, not just on protocol
            and hostname.
          + Adding a validate button and result textbox to the dynamic tag
            editor.
          + Added confirmation dialogs to removal methods (can be disabled
            via about:config setting "enableConfirmationDialogs").
          + New hidden feature "matchAgainstLabels".
            Can be enabled via about:config by setting
            extensions.autofillForms@blueimp.net.matchAgainstLabels to
            true.
            If enabled, matches the fieldRules against the textual content
            of label tags assigned to the current element if the element
            name does not match.
          + Added a new help section: "Hidden settings".
          + The focus is now set on the last form element match - this
            allows to submit autofilled forms by hitting the enter key.
     * Bugfixes:
          + Pressing the delete key (keyCode 46) doesn't call the remove
            method anymore if a textbox is focused.
          + The nsISecretDecoderRing methods encryptString/decryptString
            cannot handle characters above the Latin-1 (ISO-8859-1)
            charset.
            The usage of encodeURI/decodeURI on the fieldRule properties
            bypasses this problem as a workaround.

      Version 0.8.0.1

   27.11.2007
     * Bugfixes:
          + Selecting an item right after changing a textbox value does
            not fire any onchange/onblur events which resulted in the
            changes not being saved.
            Applying the changes on the last selected item on a new
            selection as workaround.
          + Changes applied if more than one item has been selected could
            result in the wrong item being updated.

      Version 0.8.0.2

   29.11.2007
     * Bugfixes:
          + The settings page didn't allow to enable the global profile -
            the enableGlobalProfile preference tag was missing inside the
            XUL document.

      Version 0.8.0.3

   30.11.2007
     * New features:
          + Added (hidden) statusbar icon - can be made visible via
            about:config setting
            extensions.autofillForms@blueimp.net.hideStatusbarIcon.

      Version 0.8.1

   17.12.2007
     * New features:
          + Added context menu item for form fields, allowing easier
            creation of Autofill Forms rules.
          + Updated help section.

      Version 0.8.1.1

   17.12.2007
     * Changes:
          + Updated french locale - thanks to myahoo.

      Version 0.8.1.2

   20.12.2007
     * Changes:
          + Updated italian locale - thanks to gonzalopirobutirro and
            Godai71.

      Version 0.8.2

   31.01.2008
     * New features:
          + Improved alternatives code and added alternatives support for
            selections and radio buttons.
          + Added "about:config" option "useConfigDirectory" which allows
            to store the fieldRules, dynamicTags and dynamicTagCodes as
            files.
            The files are stored in the directory
            "autofillForms@blueimp.net" beneath the Firefox profile
            directory by default.
            This can be changed using the "about:config" option
            "configDirectory" - it is recommended to keep the default.

      Version 0.9

   16.02.2008
     * New features:
          + Added a more intuitive and much simpler interface to edit the
            field rules in addition to the main editing pane.
          + Made several hidden features accessible on the settings page.
          + Added button to reset all profiles to the simple interface
            pane.
          + Made sure profiles always get a unique name (label change,
            import or adding of profiles).
          + Slightly improved the default profile rules.
          + Added a toolbar button without menu (but with context menu).
     * Other changes:
          + Unsetting the fieldRules object after each fillForms call
            instead of keeping them in memory.
          + Storing the profile labels as file if useConfigDirectory is
            enabled.

      Version 0.9.1

   23.03.2008
     * New features:
          + Added the possibility to restrict profiles to certain websites
            by setting a profile site rule.
          + Added an option to automatically select the best matching
            profile dependent on the form url and the profile site rules.
     * Bugfixes:
          + Editing a rule with the rule editor did not apply the changes
            automatically on confirmation.

      Version 0.9.1.1

   25.03.2008
     * New features:
          + Added a selection of the available profiles to the Autofill
            Forms menu popup.
     * Bugfixes:
          + Fixed a bug preventing the proper selection of the best
            matching profile.
     * Other changes:
          + The option autoSelectBestProfile is now enabled by default.
          + The current profile is now declared best match for equal match
            lengths instead of the first matching profile in the list.
          + Resetting the profile to the manually selected one after using
            the best matching profile.
            This can be disabled by setting the "about:config" option
            "resetProfileAfterAutoSelect" to false.

      Version 0.9.2

   06.04.2008
     * New features:
          + Added the possibility to add a complete web form as Autofill
            Forms profile (by using the context menu of a form field).
     * Bugfixes:
          + Added a workaround for the missing integrated help system
            which has been removed for Firefox 3.0b5 and later.
     * Other changes:
          + Adding new rules to the start of the list (or right after the
            selection) instead of to the end.
          + Added the regular expression for valid form field types as
            "about:config" option.
          + Hiding passwords in the simple interface and in the rules list
            behind asterisks (*).
            Passwords are defined by the label/name of a rule which is
            compared to a regular expression (regExpPasswordLabel in
            "about:config").

      Version 0.9.2.1

   10.04.2008
     * Changes:
          + Updated french locale - thanks to myahoo.

      Version 0.9.2.2

   11.04.2008
     * New features:
          + Added new example dynamic tag <clipboard> to insert the
            current clipboard text content.
            The dynamic tag code to access the clipboard text is
            this.getClipboardText().
     * Other changes:
          + Updated czech locale - thanks to PetrTwo.

      Version 0.9.2.3

   24.04.2008
     * Bugfixes:
          + Fixed a bug which caused form element labels not assigned to
            any form element to always match.

      Version 0.9.3

   08.05.2008
     * New features:
          + Added the possibility to manually fill out form fields via
            their context menu.
            This allows to insert data from the profiles while ignoring
            the form field rules.
          + Added support for element ids as fallback if a form element
            has no name or label assigned.
          + Added support to match form fields by position.
            This new feature is currently a hiddden option and has to be
            enabled via about:config (matchAgainstPositions).
            Position rules are identified by the character "#" adjustable
            via about:config (positionsIdentifier).
            A rule matching always the second form element would be "#2".
            Another rule matching the third element on the second form
            would be "2#3".
            You can also combine matching form field names with matching
            form field positions:
            A rule matching the second form field or fields with the name
            "test" would be "(test)|(#2)".

      Version 0.9.4

   28.05.2008
     * New features:
          + Automatically installing the toolbar button.
          + Added option to hide/display the toolbar button.
          + Added option to hide/display the toolbar button menu.
          + Middle mouse click on toolbar button or statusbar icon allows
            filling out forms by profile.
          + New content area context menu item allows filling out forms by
            profile.
     * Bugfixes:
          + Fixed a bug preventing shortcut key combinations with keycodes
            (e.g. VK_ENTER) to work on Firefox 3 RC1.
          + Escaping special regexp characters in field names when adding
            them as new rules via the context menu.
     * Other changes:
          + Removed the integrated help in favor of an online help.

      Version 0.9.4.1

   03.06.2008
     * New features:
          + Making all icons completely customizable via user CSS
            (userChrome.css).
     * Other changes:
          + Updating the help topics for the different settings dialogs.

      Version 0.9.4.2

   03.06.2008
     * Bugfixes:
          + Fixing a bug related to the toolbar button style.

      Version 0.9.5

   28.06.2008
     * New features:
          + Added new settings tabs for profile management.
          + Added the possibility to define keyboard shorcuts to autofill
            and submit forms, to autofill forms on all tabs and to fill
            forms from profile selection.
          + Added the possibility to configure different actions for
            different mouse button clicks on toolbar button and statusbar
            icon.
          + Adding access to all hidden preferences (except
            regExpFormFieldTypes and regExpPasswordLabel) to the settings
            dialog.
          + Rule values are now matched as regular expressions against
            selection options, checkboxes and radio buttons.
          + Improved performance by caching rules (and their regular
            expressions) within one form filling run.
          + Added option to identify form field labels which are no strict
            HTML label elements - the default is to identify labels in
            strict mode.
     * Bugfixes:
          + Adjusting the toolbar icons to the default theme on Firefox 3
            for Mac.
          + Added a fix to show only a selection between radio buttons if
            the alternative rules are placed next to each other or the
            rule is the same.
     * Other changes:
          + Alternatives must be placed next to each other and match the
            field, but don't require the same field rule anymore.
          + Replacing control characters with placeholders when adding a
            new rule or profile via the context menu of form fields.
          + Replacing control characters with placeholders on text input
            for the rule values (Firefox >= 3).
          + Adding a preference for the tabulator placeholder (by default
            four space characters).
          + Adding version specific stylesheets instead of modifying the
            styles via JavaScript.
          + Adding the global skin as CSS import rule instead of inside
            the XUL files.
          + Suggesting the profile name as filename on profile export.
          + Automatically applying new keyboard shortcuts on key input.
          + Disabled rules are now moved to a submenu on the form fields
            context menu.
          + Reorganized the settings tabs.
          + Moved the "Display form details" command to the content area
            context menu.
          + Replaced the former "Display form details" button with the
            "Reset all profiles button".
          + Removed the unnecessary preference
            "resetProfileAfterAutoSelect".
          + Allow to use Autofill Forms on other protocols than
            http(s)://; e.g. on file:// to test local HTML forms.
          + Adding a default label for empty profile labels.
          + Adding all options of selections of type multiple as rules
            when adding a form as profile.

      Version 0.9.5.1

   13.07.2008
     * New features:
          + Added the possibility to configure keyboard shortcut and mouse
            button for the "Display Form Details" feature.
          + Added (incomplete) romanian locale - thanks to x10firefox at
            babelzilla.org.
     * Bugfixes:
          + Adjust the hideToolbarButton setting if the toolbar button has
            been removed/added by drag and drop.
     * Other changes:
          + Code refactoring to improve performance and readability -
            thanks to Robert Stewart for the performance notions.

      Version 0.9.5.2

   30.08.2008
     * Bugfixes:
          + Adjusting the "Add complete form as profile..." and "Add a
            rule for this field..." features to add the values of non-text
            fields as regular expressions.
            Adding the special characters for the beginning and end of the
            string makes sure no unwanted alternatives prompts are shown.
     * Other changes:
          + Use gBrowser if it is available and the WindowMediator service
            only as fallback to access the browser object.
          + Replaced multiple method calls to access the content document
            with local variables holding the document reference.
          + Parsing child frames after parsing the parent window.
